#ifndef RAND_EX2_H
#define RAND_EX2_H

#include <boost\random.hpp>

namespace boost_ex {

using namespace boost;


//just a simple class template to extend the boost random classes is the
//obvious ways.
template <class Rand = mt19937, class result_type = uint32_t>
struct Rand_Ex : public Rand {
	Rand_Ex() {}
	Rand_Ex(result_type s) : Rand(s) {}

	//normalized floating point random number
	double frand_norm() { return operator()()/((double)(max()-min())); }

	//obviously, chance will only work if you are using a uniform distrubtion
	bool chance(double c) { return frand_norm()<=c; }

	//Random value in [0:n)
	//similar to the one you find in C++3e::686
	result_type operator()(result_type n) { 
		result_type r= n*frand_norm(); 
		return (r==n) ? n-1 : r; 
	}
	result_type operator()() { return Rand::operator()(); }
};

}

#endif