#ifndef STDINCLUDES_H
#define STDINCLUDES_H

#pragma warning(disable: 4786)

#include <stdio.h>
#include <windows.h>		// Header File For Windows
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include <stdarg.h>			// Header File For Variable Argument Routines
#include <math.h>

#include <vector>
#include <fstream>
#include <iostream>
#include <string>

using namespace std; 

#ifndef PI
#define PI 3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679
#endif

#ifndef RAD2DEG
#define RAD2DEG 180./PI
#endif

//something like this really should have been included in the vector class
template<class T>
bool member(const T &el, const vector<T> &v) {
	for(int i=0;i<v.size();i++) if(v[i]==el) return true;
	return false;
}

//something like this really should have been included in the vector class
template<class T>
int index(const T &el, const vector<T> &v) {
	for(int i=0;i<v.size();i++) if(v[i]==el) return i;
	return -1;
}

inline float sq(float x) { return x*x; }


#define NAME char name[30]
//a handy macro, I use it for color arrays
#define SET4(a, r, g, b, w) a[0]=r; a[1]=g; a[2]=b; a[3]=w; 

#endif